Index: /trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java	(revision 8313)
@@ -62,13 +62,9 @@
 import org.greenstone.gatherer.gui.WarningDialog;
 import org.greenstone.gatherer.gui.tree.WorkspaceTree;
-import org.greenstone.gatherer.msm.ElementWrapper;
-import org.greenstone.gatherer.msm.MetadataXMLFileManager;
-import org.greenstone.gatherer.msm.GreenstoneArchiveParser;
-import org.greenstone.gatherer.msm.LegacyCollectionImporter;
-import org.greenstone.gatherer.msm.MetadataSet;
-import org.greenstone.gatherer.msm.MetadataSetManager;
-import org.greenstone.gatherer.msm.MSMEvent;
-import org.greenstone.gatherer.msm.MSMListener;
-import org.greenstone.gatherer.msm.MSMProfiler;
+import org.greenstone.gatherer.metadata.DocXMLFileManager;
+import org.greenstone.gatherer.metadata.MetadataSet;
+import org.greenstone.gatherer.metadata.MetadataSetManager;
+import org.greenstone.gatherer.metadata.MetadataXMLFileManager;
+import org.greenstone.gatherer.metadata.ProfileXMLFileManager;
 import org.greenstone.gatherer.shell.GShell;
 import org.greenstone.gatherer.shell.GShellEvent;
@@ -89,7 +85,6 @@
  */
 public class CollectionManager
-    implements GShellListener, MSMListener {
-    /** A reference to the metadata set manager. */
-    public MetadataSetManager msm;
+    implements GShellListener {
+
     /** Are we currently in the process of building? */
     private boolean building = false;
@@ -100,6 +95,4 @@
     /** The collection_model. */
     private FileSystemModel collection_model = null;
-    /** The workspace model. This becomes invalid on a collection change. */
-    // private FileSystemModel workspace_model = null;
     /** An inner class listener responsible for noting tree changes and resetting saved when they occur. */
     private FMTreeModelListener fm_tree_model_listener = null;
@@ -127,9 +120,12 @@
 	this.collection = null;
     }
+
+
     /** Add a special directory mapping.
      * @param name The name for this directory mapping as a <strong>String</strong>.
      * @param file The directory this mapping maps to as a <strong>File</strong>.
      */
-    public void addDirectoryMapping(String name, File file) {
+    public void addDirectoryMapping(String name, File file)
+    {
 	// Update the information stored in the Gatherer config
 	Configuration.addDirectoryMapping(name, file);
@@ -137,4 +133,6 @@
 	Gatherer.g_man.refreshWorkspaceTree(WorkspaceTree.FOLDER_SHORTCUTS_CHANGED);
     }
+
+
     /** This method calls the builcol.pl scripts via a GShell so as to not lock up the processor.
      * @see org.greenstone.gatherer.Configuration
@@ -147,5 +145,5 @@
      * @see org.greenstone.gatherer.util.Utility
      */
-    public void buildCollection() {
+    private void buildCollection() {
 	DebugStream.println("CollectionManager.buildCollection()");
 	building = true;
@@ -227,7 +225,12 @@
 	lock_file.delete();
 	if(lock_file.exists()) {
-	   System.err.println("Lockfile was not successfully deleted.");
-	}
-	collection.msm.destroy();
+	    System.err.println("Lockfile was not successfully deleted.");
+	}
+
+	MetadataSetManager.clearMetadataSets();
+	MetadataXMLFileManager.clearMetadataXMLFiles();
+	DocXMLFileManager.clearDocXMLFiles();
+	ProfileXMLFileManager.clearProfileXMLFile();
+
 	collection = null;
 	collection_model = null;
@@ -324,7 +327,6 @@
      * @param metadata_sets if the user has decided to select several metadata sets with which to initially populate the GLI then this is an ArrayList of metadata set file names, otherwise its null
      */
-    public void createCollection(String description, String email, String name, String title, File base_collection_directory, ArrayList metadata_sets) {
-	boolean cancelled = false;
-
+    public void createCollection(String description, String email, String name, String title, File base_collection_directory, ArrayList metadata_sets)
+    {
 	try {
 	    // first make sure that the collect directory exists
@@ -340,11 +342,11 @@
 	    // *******************
 	    //check that this creation has worked - simply by checking for the existence of the collect.cfg file
-	    String a_dir;
+	    String collection_dir;
 	    if (Gatherer.GS3) {
-		a_dir = Utility.getCollectionDir(Configuration.gsdl3_path, Configuration.site_name, name);
+		collection_dir = Utility.getCollectionDir(Configuration.gsdl3_path, Configuration.site_name, name);
 	    } else {
-		a_dir = Utility.getCollectionDir(Configuration.gsdl_path, name);
-	    }
-	    File config_file = new File(Utility.getConfigFile(a_dir));
+		collection_dir = Utility.getCollectionDir(Configuration.gsdl_path, name);
+	    }
+	    File config_file = new File(Utility.getConfigFile(collection_dir));
 	    if (!config_file.exists()) {
 		// no point continuing
@@ -356,5 +358,5 @@
  	    
 	    // ACTIVE_DIR/log/
-	    File log_dir_temp = new File(Utility.getLogDir(a_dir)+"temp.dat");
+	    File log_dir_temp = new File(Utility.getLogDir(collection_dir)+"temp.dat");
 	    File log_dir = log_dir_temp.getParentFile();
 	    log_dir.mkdirs();
@@ -364,5 +366,5 @@
 
 	    // Make sure an import folder exists
-	    File import_directory = new File(Utility.getImportDir(a_dir));
+	    File import_directory = new File(Utility.getImportDir(collection_dir));
 	    if (!import_directory.exists()) {
 		import_directory.mkdirs();
@@ -372,35 +374,30 @@
 
 	    // Now create the collection object around the directory.
-	    collection = new Collection(new File(a_dir, name + ".col"));
-	    collection.msm = new MetadataSetManager();
-	    msm = collection.msm; // Legacy
-	    collection.msm.load();
-
-	    // Import default metadata sets if any.
-	    for(int i = 0; metadata_sets != null && i < metadata_sets.size(); i++) {
-		MetadataSet metadata_set = (MetadataSet) metadata_sets.get(i);
-		collection.msm.importMDS(metadata_set.getFile(), false);
-	    }
-
-	    boolean skip_import_phase = false;
+	    collection = new Collection(new File(collection_dir, name + ".col"));
+
+	    MetadataSetManager.clearMetadataSets();
+	    MetadataXMLFileManager.clearMetadataXMLFiles();
+	    DocXMLFileManager.clearDocXMLFiles();
+
+	    // Import default metadata sets, if any
+	    for (int i = 0; metadata_sets != null && i < metadata_sets.size(); i++) {
+		importMetadataSet((MetadataSet) metadata_sets.get(i));
+	    }
+
+	    ProfileXMLFileManager.loadProfileXMLFile(new File(collection_dir, Utility.META_DIR));
 
 	    // Before we create the CollectionDesignManager we have to check if we are basing it upon some other collection.
-	    if(base_collection_directory != null) {
-	       DebugStream.println("Basing new collection on existing one: " + base_collection_directory);
-	       collection.setBaseCollection(base_collection_directory.getAbsolutePath());
-	       // copy over other needed directories
-	       copyExtraBaseCollStuff(new File(a_dir), base_collection_directory);
-		// Try to import any existing metadata sets for this collection. Look in base_collection_directory/metadata and import any metadata sets found.
-		File base_metadata = new File(base_collection_directory, Utility.META_DIR);
-		if(base_metadata.exists()) {
-		    DebugStream.println("Found the metadata directory.");
-		    File[] possible_metadata_sets = base_metadata.listFiles();
-		    for(int i = 0; possible_metadata_sets != null && i < possible_metadata_sets.length; i++) {
-			String filename = possible_metadata_sets[i].getName();
-			if(filename.endsWith(".mds")) {
-			    DebugStream.println("+ Found a metadata set. Importing: " + possible_metadata_sets[i].getAbsolutePath());
-			    collection.msm.importMDS(possible_metadata_sets[i], false);
-			    skip_import_phase = true;
-			}
+	    if (base_collection_directory != null) {
+		DebugStream.println("Basing new collection on existing one: " + base_collection_directory);
+		collection.setBaseCollection(base_collection_directory.getAbsolutePath());
+		// copy over other needed directories
+		copyExtraBaseCollStuff(new File(collection_dir), base_collection_directory);
+		// Try to import any existing metadata sets for this collection
+		// Look in base_collection_directory/metadata and import any metadata sets found.
+		File base_metadata_directory = new File(base_collection_directory, Utility.META_DIR);
+		ArrayList base_metadata_sets = MetadataSetManager.listMetadataSets(base_metadata_directory);
+		if (base_metadata_sets != null) {
+		    for (int i = 0; i < base_metadata_sets.size(); i++) {
+			importMetadataSet((MetadataSet) base_metadata_sets.get(i));
 		    }
 		}
@@ -408,68 +405,36 @@
 		    DebugStream.println("This base collection has no metadata directory.");
 		}
-		// If no sets were imported, then create a new metadata with this new collections name.
-		if(collection.msm.getSets().size() == 0) {
+
+		// If no sets were imported...
+		if (MetadataSetManager.getMetadataSets().size() == 0) {
 		    // Prompt the user so that they can choose at least one initial metadata set. We're sneaky here and just create a ncm_prompt
 		    DebugStream.println("This collection has no metadata sets. Present the user with the metadata set selection prompt.");
 		    NewCollectionMetadataPrompt ncm_prompt = new NewCollectionMetadataPrompt();
 		    // If cancelled then they really do mean to start a collection with no metadata sets.
-		    if(!ncm_prompt.isCancelled()) {
+		    if (!ncm_prompt.isCancelled()) {
 			ArrayList initial_sets = ncm_prompt.getSets();
-			for(int i = 0; initial_sets != null && i < initial_sets.size(); i++) {
-			    MetadataSet metadata_set = (MetadataSet) initial_sets.get(i);
-			    collection.msm.importMDS(metadata_set.getFile(), false);
-			    metadata_set = null;
+			for (int i = 0; initial_sets != null && i < initial_sets.size(); i++) {
+			    importMetadataSet((MetadataSet) initial_sets.get(i));
 			}
-			initial_sets = null;
 		    }
 		    ncm_prompt.dispose();
 		    ncm_prompt = null;
 		}
-		// Do a dry metadata import run over the entire base collection, recording profile mappings. We do this by finding the archive files, and then iterating over them using the GreenstoneArchiveParser to retrieve metadata from them. We then process the importing of new metadata elements using the selectElement prompt used in a file action metadata import. However the big change is that we don't actually import any metadata, just create importing profiles.
-		if(!skip_import_phase) {
-		    File base_archive = new File(base_collection_directory, Utility.ARCHIVES_DIR);
-		    if(base_archive.exists()) {
-			DebugStream.println("+ Archive directory found. Inspecting archives for metadata information.");
-			ArrayList metadata_elements = GreenstoneArchiveParser.extractMetadataElements(base_archive);
-			for(int i = 0; !cancelled && i < metadata_elements.size(); i++) {
-			    String metadata_name = (String) metadata_elements.get(i);
-			    ElementWrapper target = collection.msm.prompt.selectElement(metadata_name);
-			    cancelled = Gatherer.c_man.getCollection().msm.prompt.wasDialogCancelled();
-			    if(!cancelled) {
-				if(target != null) {
-				    collection.msm.profiler.addAction(base_collection_directory.getAbsolutePath(), metadata_name, target.getName());
-				}
-				else {
-				    collection.msm.profiler.addAction(base_collection_directory.getAbsolutePath(), metadata_name, null);
-				}
-			    }
-			}
-			// Hopefully mappings should now be in place for metadata extracted from this collection.
-		    }
-		    else {
-			DebugStream.println("+ Searching files for metadata.xml information.");
-			// Find the import directory
-			File base_import = new File(base_collection_directory, Utility.IMPORT_DIR);
-			if(base_import.exists()) {
-			    searchForMetadata(base_import);
-			}
-		    }
-		}
-		// And if that fails then we must have been asked by Satan himself to build the very digital collections of hell, because they don't match any goodly greenstone collection I have ever seen, so you can't blame me if I can't import them.
 
 		// Now we update our collect.cfg
 		DebugStream.println("Copy and update collect.cfg from base collection.");
-		updateCollectionCFG(new File(base_collection_directory, Utility.CONFIG_FILE), new File(a_dir, Utility.CONFIG_FILE), description, email, title);
+		updateCollectionCFG(new File(base_collection_directory, Utility.CONFIG_FILE), new File(collection_dir, Utility.CONFIG_FILE), description, email, title);
 	    }
 
 	    // Always import the extracted metadata set if we didn't already
-	    if(collection.msm.getSet(Utility.EXTRACTED_METADATA_NAMESPACE) == null) {
-	       collection.msm.importMDS(new File(Utility.METADATA_DIR + Utility.EXTRACTED_METADATA_NAMESPACE + StaticStrings.METADATA_SET_EXTENSION), false);
+	    if (MetadataSetManager.getMetadataSet(MetadataSetManager.EXTRACTED_METADATA_NAMESPACE) == null) {
+		File extracted_metadata_set_file = new File(Utility.METADATA_DIR + Utility.EXTRACTED_METADATA_NAMESPACE + StaticStrings.METADATA_SET_EXTENSION);
+		importMetadataSet(new MetadataSet(extracted_metadata_set_file));
 	    }
 
 	    collection.cdm = new CollectionDesignManager(new File(getCollectionConfig()));
-	    
+
 	    // Now that we have a CDM, update several settings, such as if we created this collection by basing it on another, set it as public automatically
-	    if(base_collection_directory != null) {
+	    if (base_collection_directory != null) {
 		// Update the creator and maintainer
 		CollectionMeta creator_collectionmeta = new CollectionMeta(collection.cdm.collect_config.getCreator());
@@ -479,16 +444,20 @@
 		maintainer_collectionmeta.setValue(email);
 		maintainer_collectionmeta = null;
+
 		// Update the collection title
 		CollectionMeta collection_name_collectionmeta = collection.cdm.collectionmeta_manager.getMetadatum(StaticStrings.COLLECTIONMETADATA_COLLECTIONNAME_STR);
 		collection_name_collectionmeta.setValue(title);
 		collection_name_collectionmeta = null;
+
 		// And now the description
 		CollectionMeta collection_extra_collectionmeta = collection.cdm.collectionmeta_manager.getMetadatum(StaticStrings.COLLECTIONMETADATA_COLLECTIONEXTRA_STR);
 		collection_extra_collectionmeta.setValue(description);
 		collection_extra_collectionmeta = null;
+
 		// All collections based on others are automatically public
 		CollectionMeta public_collectionmeta = new CollectionMeta(collection.cdm.collect_config.getPublic());
 		public_collectionmeta.setValue(StaticStrings.TRUE_STR);
 		public_collectionmeta = null;
+
 		// Finally reset the icons
 		CollectionMeta icon_collection_collectionmeta = collection.cdm.collectionmeta_manager.getMetadatum(StaticStrings.COLLECTIONMETADATA_ICONCOLLECTION_STR);
@@ -499,31 +468,16 @@
 		icon_collection_small_collectionmeta = null;
 	    }
-	    
-	    collection.gdm = new MetadataXMLFileManager();
 
 	    progress.setProgress(3);
 
-	    // Has to be done after creating metadata set manager.
-	    File gmeta_dir_temp = new File(getCollectionMetadata()+"temp.dat");
-	    File gmeta_dir = gmeta_dir_temp.getParentFile();
-	    gmeta_dir.mkdirs();
-	    if(progress != null) {
-		progress.setNote("GMeta created");
-	    }
-	    progress.setProgress(4);
-
-	    progress.setProgress(6);
-	    // Register ourselves as being interested in what the msm has to say.
-	    collection.msm.addMSMListener(this);
 	    // Create a lock file.
-	    File lock_file = new File(a_dir, LOCK_FILE);
+	    File lock_file = new File(collection_dir, LOCK_FILE);
 	    FileOutputStream out = new FileOutputStream(lock_file);
 	    out.write(LOCK_FILE.getBytes());
 	    out.close();
 	    out = null;
+
 	    progress.setProgress(7);
-	    String args[] = new String[1];
-	    args[0] = name;
-	    progress.setNote(Dictionary.get("CollectionManager.Session_Ready", args));
+	    progress.setNote(Dictionary.get("CollectionManager.Session_Ready", name));
 	    progress.close();
 	}
@@ -543,4 +497,5 @@
 	}
     }
+
 
     public void createLockFile(File destination) {
@@ -569,19 +524,4 @@
     }
 
-    /** Method that is called whenever an element within a set is changed or modified. We want to mark the collection so that it needs saving again.
-     * @param event A <strong>MSMEvent</strong> containing details of the event that caused this message to be fired.
-     * @see org.greenstone.gatherer.collection.Collection
-     */
-    public void elementChanged(MSMEvent event) {
-	// This means the state of the collections has changed, so we should set saved to false.
-	collection.setSaved(false);
-    }
-    /** Used to retrieve the build options associated with the currently loaded collection. If none yet exist, default ones are created.
-     * @return A <strong>BuildOptions</strong> object containing the build options for the current collection.
-     * @see org.greenstone.gatherer.collection.Collection
-     */
-    /* private BuildOptions getBuildOptions() {
-	return collection.build_options;
-	} */
 
     /** Retrieve the current collection.
@@ -591,4 +531,6 @@
 	return collection;
     }
+
+
     /** Constructs the absolute filename of the collection archive directory, which should resemble "$GSDLHOME/collect/&lt;col_name&gt;/archive/"
      * @return A <strong>String</strong> containing the filename.
@@ -630,5 +572,5 @@
 	    return Utility.getConfigFile(Utility.getCollectionDir(Configuration.gsdl3_path, Configuration.site_name, collection.getName()));
 	} else {
-	return Utility.getConfigFile(Utility.getCollectionDir(Configuration.gsdl_path, collection.getName()));
+	    return Utility.getConfigFile(Utility.getCollectionDir(Configuration.gsdl_path, collection.getName()));
 	}
     }
@@ -660,5 +602,5 @@
 	    return Utility.getEtcDir(Utility.getCollectionDir(Configuration.gsdl3_path, Configuration.site_name, collection.getName()));
 	} else {
-	return Utility.getEtcDir(Utility.getCollectionDir(Configuration.gsdl_path, collection.getName()));
+	    return Utility.getEtcDir(Utility.getCollectionDir(Configuration.gsdl_path, collection.getName()));
 	}
     }
@@ -674,5 +616,5 @@
 	    return Utility.getCollectionDir(Configuration.gsdl3_path, Configuration.site_name, collection.getName()) + collection.getName() + ".col";
 	} else {
-	return Utility.getCollectionDir(Configuration.gsdl_path, collection.getName()) + collection.getName() + ".col";
+	    return Utility.getCollectionDir(Configuration.gsdl_path, collection.getName()) + collection.getName() + ".col";
 	}
     }
@@ -688,5 +630,5 @@
 	    return Utility.getImagesDir(Utility.getCollectionDir(Configuration.gsdl3_path, Configuration.site_name, collection.getName()));
 	} else {
-	return Utility.getImagesDir(Utility.getCollectionDir(Configuration.gsdl_path, collection.getName()));
+	    return Utility.getImagesDir(Utility.getCollectionDir(Configuration.gsdl_path, collection.getName()));
 	}
     }
@@ -748,14 +690,14 @@
     }
 
-    /** This method either returns the title of the current collection, or a placeholder string of 'No Collection'.
-     * @return A <strong>String</strong> which represents what we wish to display for a collection title.
-     * @see org.greenstone.gatherer.collection.Collection
-     */
-    /* private String getCollectionTitle() {
-	if(collection != null) {
-	    return collection.getTitle();
-	}
-	return Dictionary.get("Collection.No_Collection");
-	} */
+
+    static public String getCollectionMetadataDirectory()
+    {
+	if (Gatherer.GS3) {
+	    return Utility.getMetadataDir(Utility.getCollectionDir(Configuration.gsdl3_path, Configuration.site_name, collection.getName()));
+	} else {
+	    return Utility.getMetadataDir(Utility.getCollectionDir(Configuration.gsdl_path, collection.getName()));
+	}
+    }
+	
 
     /** Retrieve the record set (tree model) associated with the current collection. */
@@ -827,18 +769,17 @@
 	    index_dir = index_dir.getParentFile();
 	    if(index_dir.exists()) {
-	       DebugStream.println("Old Index = " + index_dir.getAbsolutePath()+", testing for deletability");
-	       if (!canDelete(index_dir)) {
-		   // tell the user
-		   JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("CollectionManager.Cannot_Delete_Index"), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE); 
-		   // tell the gui manager
-		   // a message for the building log 
-		   GShellEvent event = new GShellEvent(this, 0, GShell.IMPORT, Dictionary.get("CollectionManager.Cannot_Delete_Index_Log"), GShell.ERROR);
-		   Gatherer.g_man.create_pane.message(event);
-		   event = new GShellEvent(this, 0, GShell.IMPORT, "", GShell.ERROR);
-		   Gatherer.g_man.create_pane.processComplete(event);
-		   importing = false;
-		   return;
-	       }
-	       
+		DebugStream.println("Old Index = " + index_dir.getAbsolutePath()+", testing for deletability");
+		if (!canDelete(index_dir)) {
+		    // tell the user
+		    JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("CollectionManager.Cannot_Delete_Index"), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE); 
+		    // tell the gui manager
+		    // a message for the building log 
+		    GShellEvent event = new GShellEvent(this, 0, GShell.IMPORT, Dictionary.get("CollectionManager.Cannot_Delete_Index_Log"), GShell.ERROR);
+		    Gatherer.g_man.create_pane.message(event);
+		    event = new GShellEvent(this, 0, GShell.IMPORT, "", GShell.ERROR);
+		    Gatherer.g_man.create_pane.processComplete(event);
+		    importing = false;
+		    return;
+		}
 	    }
 
@@ -879,4 +820,31 @@
     }
 
+
+    public void importMetadataSet(MetadataSet external_metadata_set)
+    {
+	// Copy the .mds file into the collection's "metadata" folder...
+	File external_metadata_set_file = external_metadata_set.getMetadataSetFile();
+
+	// ...but not if it is the redundant "hidden.mds" file
+	if (external_metadata_set_file.getName().equals("hidden.mds")) {
+	    return;
+	}
+
+	// ...and only if it doesn't already exist
+	File metadata_set_file = new File(getCollectionMetadata(), external_metadata_set_file.getName());
+	if (!metadata_set_file.exists()) {
+	    try {
+		Gatherer.f_man.getQueue().copyFile(external_metadata_set_file, metadata_set_file, null);
+	    }
+	    catch (Exception ex) {
+		ex.printStackTrace();
+	    }
+
+	    // Load it into the MetadataSetManager
+	    MetadataSetManager.loadMetadataSet(metadata_set_file);
+	}
+    }
+
+
     /** Determine if we are currently in the middle of importing (and thus, in this case, we can't allow the log writer to exit). Boy was this a mission to track down. The cascade of crap rolls out something like this: Joe Schmo clicks 'Build Collection', which calls the importCollection() method above, which in turn saves the collection with a saveTask, which fires a collectionChanged message once its finished, which drives the list of logs shown on the create pane to update, which fires a itemChanged() event to the OptionsPane who dutifully tells the current log writer thread to finish up writing (all zero lines its been asked to write) and then die. Wereapon Joe Schmo gets a pretty log to look at, but it isn't actually being written to file so the next time he tries to view it faeces hits the air motion cooling device. Joy.
      * @return true if the gli is currently importing
@@ -891,26 +859,23 @@
      * @see org.greenstone.gatherer.Gatherer
      * @see org.greenstone.gatherer.collection.Collection
-     * @see org.greenstone.gatherer.msm.MetadataSetManager
-     * @see org.greenstone.gatherer.msm.MSMListener
      * @see org.greenstone.gatherer.util.Utility
      */
-    public boolean loadCollection(String location) {
-	DebugStream.println("Load Collection '" + location + "'");
-	String[] args2 = new String[1];
-	args2[0] = location;
-	boolean result = false;
+    public boolean loadCollection(String location)
+    {
+	DebugStream.println("Loading collection " + location + "...");
 	boolean non_gatherer_collection = false;
+
 	// Check we have actually been given a .col file.
-	if(!location.endsWith(".col")) {
-	    JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("CollectionManager.Not_Col_File", args2), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
+	if (!location.endsWith(".col")) {
+	    JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("CollectionManager.Not_Col_File", location), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
 	    DebugStream.println("CollectionManager.loadCollection: Haven't been given a .col file.");
 	    return false;
 	}
+
 	// Check that there is the collection configuration file available
-
 	File collection_file = new File(location);
 	// Ensure that the directory exists.
 	File collection_directory = collection_file.getParentFile();
-	if(!collection_directory.exists()) {
+	if (!collection_directory.exists()) {
 	    // we cant open this
 	    collection_directory = null;
@@ -926,35 +891,32 @@
 
 	// Special case of a user trying to open an old greenstone collection.
-	File metadata_directory = new File(collection_directory, Utility.META_DIR);
-	if(!metadata_directory.exists()) {
-
-	    DebugStream.println("CollectionManager.loadCollection: trying to load up a non-gatherer collection");
+	File collection_metadata_directory = new File(collection_directory, Utility.META_DIR);
+	if (!collection_metadata_directory.exists()) {
+	    DebugStream.println("Loading non-gatherer collection...");
 	    non_gatherer_collection = true;
 	}
 
+	// Now determine if a lock already exists on this collection.
 	String name = collection_directory.getName();
 	File lock_file = new File(collection_file.getParentFile(), LOCK_FILE);
-	// Now determine if a lock already exists on this collection.
-	int choice = LockFileDialog.YES_OPTION;
-	if(lock_file.exists()) {
+	if (lock_file.exists()) {
 	    LockFileDialog dialog = new LockFileDialog(Gatherer.g_man, name, lock_file);
-	    choice = dialog.getChoice();
+	    int choice = dialog.getChoice();
 	    dialog.dispose();
 	    dialog = null;
-	}
-
-	if(choice != LockFileDialog.YES_OPTION) {
-	    // user has cancelled
-	    lock_file = null;
-	    collection_directory = null;
-	    collection_config_file = null;
-	    return false;
-	}
-
-
+
+	    if (choice != LockFileDialog.YES_OPTION) {
+		// user has cancelled
+		lock_file = null;
+		collection_directory = null;
+		collection_config_file = null;
+		return false;
+	    }
+
+	    lock_file.delete();
+	}
+
+	boolean result = false;
 	try {
-	    if(lock_file.exists()) {
-		lock_file.delete();
-	    }
 	    // Create a lock file.
 	    createLockFile(lock_file);
@@ -964,5 +926,5 @@
 		System.err.println("Cannot write lock file!");
 		String args[] = new String[2];
-		args[0] = args2[0];
+		args[0] = location;
 		args[1] = Dictionary.get("FileActions.Write_Not_Permitted_Title");
 		JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("CollectionManager.Cannot_Open_With_Reason", args), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
@@ -970,4 +932,5 @@
 		return false;
 	    }
+
 	    // Open the collection file
 	    this.collection = new Collection(collection_file);
@@ -975,5 +938,5 @@
 		collection = null;
 		// Remove lock file
-		if(lock_file.exists()) {
+		if (lock_file.exists()) {
 		    lock_file.delete();
 		}
@@ -981,11 +944,12 @@
 	    }
 
-	    collection.msm = new MetadataSetManager();
-	    msm = collection.msm; // Legacy
-	    collection.msm.load();
-	    // if non-gatherer collection, need to add some metadata sets
+	    MetadataSetManager.clearMetadataSets();
+	    MetadataSetManager.loadMetadataSets(collection_metadata_directory);
+
+	    ProfileXMLFileManager.loadProfileXMLFile(collection_metadata_directory);
+ 
+	    // If this is a non-GLI (legacy) collection, ask the user to choose some metadata sets
 	    if (non_gatherer_collection) {
 		if (!addSomeMetadataSets(collection_directory)) {
-		    // for now - return of false means its been cancelled. Any error messages should be sent from the function itself
 		    lock_file = null;
 		    collection_directory = null;
@@ -993,41 +957,45 @@
 		    return false;
 		}
-	    }
+
+		// Recurse the import folder tree, backing up the metadata.xml files before they are edited
+		LegacyCollectionImporter.backupMetadataXMLFiles(collection_directory);
+	    }
+
+	    // Read through the metadata.xml files in the import directory, building up the metadata value trees
+	    File collection_import_directory = new File(collection_directory, Utility.IMPORT_DIR);
+	    MetadataXMLFileManager.clearMetadataXMLFiles();
+	    MetadataXMLFileManager.loadMetadataXMLFiles(collection_import_directory);
+
+	    // Read through the doc.xml files in the archives directory
+	    File collection_archives_directory = new File(collection_directory, Utility.ARCHIVES_DIR);
+	    DocXMLFileManager.clearDocXMLFiles();
+	    DocXMLFileManager.loadDocXMLFiles(collection_archives_directory);
 
 	    collection.cdm = new CollectionDesignManager(collection_config_file);
 	    if (non_gatherer_collection) {
-		// We first recurse the Import folder tree, reading in any metadata.xml files, and then altering the non-namespaced element names to be valid GLI names
-		LegacyCollectionImporter lci = new LegacyCollectionImporter(collection_directory, collection.cdm);
-		lci.backupMetadataXMLFiles(collection_directory);
-		lci.importMetadata();
-		lci.updateClassifiers();
-		lci = null;
-	    }
-	    // Whether the collection is legacy or not, we should now be able to prepare the MetadataXMLFileManager
-	    collection.gdm = new MetadataXMLFileManager();
+		// Change the classifiers to use the namespaced element names
+		LegacyCollectionImporter.updateClassifiers(collection.cdm);
+	    }
 
 	    // Tell everyone that it worked.
-	    String[] args = new String[1];
-	    args[0] = name;
-	    DebugStream.println(Dictionary.get("CollectionManager.Loading_Successful", args));
-	    // Now we need to hook up classes that depend on messages from the metadata set manager to keep their content fresh.
-	    collection.msm.addMSMListener(this);
+	    DebugStream.println(Dictionary.get("CollectionManager.Loading_Successful", name));
+
 	    // We're done. Let everyone know.
-	    if(Gatherer.g_man != null) {
-		// workspace_model = null;
+	    if (Gatherer.g_man != null) {
 		Gatherer.g_man.collectionChanged(ready());
 	    }
 	    result = true;
-	} catch (Exception error) {
+	}
+	catch (Exception error) {
 	    // There is obviously no existing collection present.
 	    DebugStream.printStackTrace(error);
 	    if(error.getMessage() != null) {
 		String[] args = new String[2];
-		args[0] = args2[0];
+		args[0] = location;
 		args[1] = error.getMessage();
 		JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("CollectionManager.Cannot_Open_With_Reason", args), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
 	    }
 	    else {
-		JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("CollectionManager.Cannot_Open", args2), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
+		JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("CollectionManager.Cannot_Open", location), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
 	    }
 	}
@@ -1037,5 +1005,4 @@
 	collection_config_file = null;
 
-	args2 = null;
 	return result;
     }
